VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsContextMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IContextMenu
Implements IShellExtInit

Private m_sFiles() As String
Private m_nFiles As Byte

Private m_pOldQueryCtxMenu As Long

Private Sub Class_Initialize()

    Dim pVtable As IContextMenu
    Set pVtable = Me
    
    m_pOldQueryCtxMenu = SwapVtableEntry(ObjPtr(pVtable), 4, AddressOf QueryContextMenuVB)
    
    
End Sub

Private Sub Class_Terminate()

    Dim pVtable As IContextMenu
    Set pVtable = Me
    m_pOldQueryCtxMenu = SwapVtableEntry(ObjPtr(pVtable), 4, m_pOldQueryCtxMenu)
   
End Sub

Private Sub IContextMenu_GetCommandString(ByVal idCmd As VBShellLib.UINT, ByVal uType As VBShellLib.UINT, ByVal pwReserved As VBShellLib.UINT, ByVal pszName As VBShellLib.LPSTRVB, ByVal cchMax As VBShellLib.UINT)

    Dim szName As String
    Dim bszName() As Byte
    
    Dim sMenuHelp As String
    
    Select Case idCmd
        Case 0 'Noise
            szName = "Display Animal Noise"
        
        'Case 1 'Menu item 2
        '    szName = "Menu Item 2"
        
        'Case 2 'Menu item 3
        '    szName = "Menu Item 3"
    End Select
    
    szName = Left$(szName, cchMax) & vbNullChar
    
    Select Case uType
        Case GCS_VERBA, GCS_HELPTEXTA, GCS_VALIDATEA
            If (szName <> "") Then
                bszName = StrConv(szName, vbFromUnicode)
                CopyMemory ByVal pszName, bszName(0), UBound(bszName) + 1
            End If
        Case GCS_VERBW, GCS_HELPTEXTW, GCS_VALIDATEW
            If (szName <> "") Then
                bszName = szName
                CopyMemory ByVal pszName, bszName(0), UBound(bszName) + 1
            End If
    End Select
    
End Sub

Private Sub IContextMenu_InvokeCommand(ByVal lpcmi As VBShellLib.LPCMINVOKECOMMANDINFO)

    Dim cmi As CMINVOKECOMMANDINFO
    CopyMemory cmi, ByVal lpcmi, Len(cmi)

    Dim i As Long
    Dim sNoise As String
    sNoise = Space(255)
    
    If LOWORD(cmi.lpVerb) = 0 Then
        For i = 0 To m_nFiles - 1
            
            GetPrivateProfileString "Animal", _
                                    "Noise", _
                                    "Unknown", _
                                    sNoise, _
                                    Len(sNoise), _
                                    m_sFiles(i)
            
            MsgBox Trim(sNoise), vbOKOnly, "Animal Noise"
            
        Next i
    End If
    
End Sub

Private Sub IContextMenu_QueryContextMenu(ByVal hMenu As VBShellLib.hMenu, ByVal indexMenu As VBShellLib.UINT, ByVal idCmdFirst As VBShellLib.UINT, ByVal idCmdLast As VBShellLib.UINT, ByVal uFlags As VBShellLib.QUERYCONTEXTMENUFLAGS)
    'Implemented as QueryContextVB (see handler.bas)
End Sub

Private Sub IShellExtInit_Initialize(ByVal pidlFolder As VBShellLib.LPCITEMIDLIST, ByVal pDataObj As VBShellLib.IDataObject, ByVal hKeyProgID As VBShellLib.HKEY)

    Dim fmtEtc As FORMATETC
    Dim pmedium As STGMEDIUM
    Dim i As Long
    Dim lresult As Long
    Dim sTemp As String
    
    With fmtEtc
        .cfFormat = CF_HDROP
        .ptd = 0
        .dwAspect = DVASPECT_CONTENT
        .lIndex = -1
        .TYMED = TYMED_HGLOBAL
    End With
    
    
    pDataObj.GetData fmtEtc, pmedium
    
    m_nFiles = DragQueryFile(pmedium.pData, &HFFFFFFFF, vbNullString, 0)
    
    ReDim m_sFiles(m_nFiles - 1)
    
    For i = 0 To (m_nFiles - 1)
        sTemp = String(1024, 0)
        lresult = DragQueryFile(pmedium.pData, i, sTemp, Len(sTemp))
        If (lresult > 0) Then
            m_sFiles(i) = Left$(sTemp, lresult)
        End If
    Next
    
    ReleaseStgMedium pmedium
    
End Sub

Public Property Get FileCount() As Byte
    FileCount = m_nFiles
End Property

Public Property Get FileName() As String
    'Only returns one selected file
    FileName = m_sFiles(0)
End Property
